Ruby - Bug #19906

fix kwarg memory leak
09/29/2023 11:02 PM - HParker (Adam Hess)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2:
UNKNOWN

Description
GitHub PR: hitps://github.com/ruby/ruby/pull/8556

ci info tracks kwargs and which are shared across aliases

30.times do
100_000.times do
def foo(k:); yield; end
alias bar foo

undef foo
end
puts “ps -o rss= -p #{$S$}°
end

before:
517504
531944
546228
560520
574760
589108
Related issues:
Related to Ruby - Bug #18553: Memory leak on compiling method call with kwargs Closed

Associated revisions

Revision c74dc8b4af4ef1b32f655871083fbebadcal86fa - 10/01/2023 02:55 PM - HParker (Adam Hess)

Use reference counting to avoid memory leak in kwargs
Tracks other callinfo that references the same kwargs and frees them when all references are cleared.
[bug #19906]

Co-authored-by: Peter Zhu peter@peterzhu.ca

Revision c74dc8b4af4ef1b32f655871083fbebadcal86fa - 10/01/2023 02:55 PM - HParker (Adam Hess)

Use reference counting to avoid memory leak in kwargs

Tracks other callinfo that references the same kwargs and frees them when all references are cleared.
[bug #19906]

Co-authored-by: Peter Zhu peter@peterzhu.ca

Revision c74dc8b4 - 10/01/2023 02:55 PM - HParker (Adam Hess)

Use reference counting to avoid memory leak in kwargs
Tracks other callinfo that references the same kwargs and frees them when all references are cleared.

[bug #19906]

Co-authored-by: Peter Zhu peter@peterzhu.ca

Revision ec3d81629ff193e847dcab9afb20dffa14f2582a - 10/01/2023 02:58 PM - nobu (Nobuyoshi Nakada)
[Bug #19906] Add the test

Revision ec3d81629ff193e847dcab9afb20dffa14f2582a - 10/01/2023 02:58 PM - nobu (Nobuyoshi Nakada)
[Bug #19906] Add the test

Revision ec3d8162 - 10/01/2023 02:58 PM - nobu (Nobuyoshi Nakada)
[Bug #19906] Add the test

History

#1 - 09/30/2023 04:45 AM - nobu (Nobuyoshi Nakada)

| can't reproduce it on {arm64,x86_64}-{darwin,linux}.

#2 - 10/01/2023 02:55 PM - HParker (Adam Hess)
- Status changed from Open to Closed

Applied in changeset git|c74dc8b4af4ef1b32{65587f083fbebadcal8bfa.

Use reference counting to avoid memory leak in kwargs
Tracks other callinfo that references the same kwargs and frees them when all references are cleared.
[bug #19906]

Co-authored-by: Peter Zhu peter@peterzhu.ca

#3 - 10/01/2023 06:42 PM - HParker (Adam Hess)

Updated reproduction script:
Maybe this is a better reproduction?
a = RubyVM::InstructionSequence.compile ("foo (bar: :baz)").to_binary

10.times do
500_000.times do
RubyVM: : InstructionSequence.load_from_binary (a)
end

puts ‘ps -o rss= -p #{$$}°
end

before:
79552
87224
94492
after:

13156
16620
16620
16620
16628
16672
16672
16672

#4 - 10/01/2023 07:56 PM - peterzhu2118 (Peter Zhu)
- Related to Bug #18553: Memory leak on compiling method call with kwargs added
